<?php
/**
 * InlineResponse20068ContentPanels
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20068ContentPanels Class Doc Comment
 *
 * @category Class
 * @description Ticket board panel
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20068ContentPanels implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_68_content_panels';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'name' => 'string',
        'projectId' => 'int',
        'employeeId' => 'int',
        'panelType' => 'string',
        'registerType' => 'string',
        'includeProjects' => 'bool',
        'includeSubTickets' => 'bool',
        'includeWaitingStates' => 'bool',
        'visibility' => 'string',
        'companies' => '\SLIS\Adapter\Tanss\Model\InlineResponse20068ContentCompanies[]',
        'employees' => '\SLIS\Adapter\Tanss\Model\InlineResponse20068ContentEmployees[]',
        'departments' => '\SLIS\Adapter\Tanss\Model\InlineResponse20068ContentDepartments[]',
        'tags' => '\SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTags[]',
        'ticketTypes' => '\SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTicketTypes[]',
        'ticketStatus' => '\SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTicketStatus[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'name' => null,
        'projectId' => null,
        'employeeId' => null,
        'panelType' => null,
        'registerType' => null,
        'includeProjects' => null,
        'includeSubTickets' => null,
        'includeWaitingStates' => null,
        'visibility' => null,
        'companies' => null,
        'employees' => null,
        'departments' => null,
        'tags' => null,
        'ticketTypes' => null,
        'ticketStatus' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'projectId' => 'projectId',
        'employeeId' => 'employeeId',
        'panelType' => 'panelType',
        'registerType' => 'registerType',
        'includeProjects' => 'includeProjects',
        'includeSubTickets' => 'includeSubTickets',
        'includeWaitingStates' => 'includeWaitingStates',
        'visibility' => 'visibility',
        'companies' => 'companies',
        'employees' => 'employees',
        'departments' => 'departments',
        'tags' => 'tags',
        'ticketTypes' => 'ticketTypes',
        'ticketStatus' => 'ticketStatus'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'projectId' => 'setProjectId',
        'employeeId' => 'setEmployeeId',
        'panelType' => 'setPanelType',
        'registerType' => 'setRegisterType',
        'includeProjects' => 'setIncludeProjects',
        'includeSubTickets' => 'setIncludeSubTickets',
        'includeWaitingStates' => 'setIncludeWaitingStates',
        'visibility' => 'setVisibility',
        'companies' => 'setCompanies',
        'employees' => 'setEmployees',
        'departments' => 'setDepartments',
        'tags' => 'setTags',
        'ticketTypes' => 'setTicketTypes',
        'ticketStatus' => 'setTicketStatus'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'projectId' => 'getProjectId',
        'employeeId' => 'getEmployeeId',
        'panelType' => 'getPanelType',
        'registerType' => 'getRegisterType',
        'includeProjects' => 'getIncludeProjects',
        'includeSubTickets' => 'getIncludeSubTickets',
        'includeWaitingStates' => 'getIncludeWaitingStates',
        'visibility' => 'getVisibility',
        'companies' => 'getCompanies',
        'employees' => 'getEmployees',
        'departments' => 'getDepartments',
        'tags' => 'getTags',
        'ticketTypes' => 'getTicketTypes',
        'ticketStatus' => 'getTicketStatus'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const PANEL_TYPE__DEFAULT = 'DEFAULT';
    public const PANEL_TYPE_PROJECT = 'PROJECT';
    public const REGISTER_TYPE_NONE = 'NONE';
    public const REGISTER_TYPE_COMPANY = 'COMPANY';
    public const REGISTER_TYPE_EMPLOYEE = 'EMPLOYEE';
    public const REGISTER_TYPE_DEPARTMENT = 'DEPARTMENT';
    public const REGISTER_TYPE_TAG = 'TAG';
    public const REGISTER_TYPE_TICKET_TYPE = 'TICKET_TYPE';
    public const REGISTER_TYPE_TICKET_STATUS = 'TICKET_STATUS';
    public const REGISTER_TYPE_PROJECT_PHASE = 'PROJECT_PHASE';
    public const VISIBILITY_ONLY_FOR_MYSELF = 'ONLY_FOR_MYSELF';
    public const VISIBILITY_EVERYBODY = 'EVERYBODY';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPanelTypeAllowableValues()
    {
        return [
            self::PANEL_TYPE__DEFAULT,
            self::PANEL_TYPE_PROJECT,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getRegisterTypeAllowableValues()
    {
        return [
            self::REGISTER_TYPE_NONE,
            self::REGISTER_TYPE_COMPANY,
            self::REGISTER_TYPE_EMPLOYEE,
            self::REGISTER_TYPE_DEPARTMENT,
            self::REGISTER_TYPE_TAG,
            self::REGISTER_TYPE_TICKET_TYPE,
            self::REGISTER_TYPE_TICKET_STATUS,
            self::REGISTER_TYPE_PROJECT_PHASE,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getVisibilityAllowableValues()
    {
        return [
            self::VISIBILITY_ONLY_FOR_MYSELF,
            self::VISIBILITY_EVERYBODY,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['projectId'] = $data['projectId'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['panelType'] = $data['panelType'] ?? null;
        $this->container['registerType'] = $data['registerType'] ?? null;
        $this->container['includeProjects'] = $data['includeProjects'] ?? null;
        $this->container['includeSubTickets'] = $data['includeSubTickets'] ?? null;
        $this->container['includeWaitingStates'] = $data['includeWaitingStates'] ?? null;
        $this->container['visibility'] = $data['visibility'] ?? null;
        $this->container['companies'] = $data['companies'] ?? null;
        $this->container['employees'] = $data['employees'] ?? null;
        $this->container['departments'] = $data['departments'] ?? null;
        $this->container['tags'] = $data['tags'] ?? null;
        $this->container['ticketTypes'] = $data['ticketTypes'] ?? null;
        $this->container['ticketStatus'] = $data['ticketStatus'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getPanelTypeAllowableValues();
        if (!is_null($this->container['panelType']) && !in_array($this->container['panelType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'panelType', must be one of '%s'",
                $this->container['panelType'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getRegisterTypeAllowableValues();
        if (!is_null($this->container['registerType']) && !in_array($this->container['registerType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'registerType', must be one of '%s'",
                $this->container['registerType'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getVisibilityAllowableValues();
        if (!is_null($this->container['visibility']) && !in_array($this->container['visibility'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'visibility', must be one of '%s'",
                $this->container['visibility'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id Panel id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Panel name
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets projectId
     *
     * @return int|null
     */
    public function getProjectId()
    {
        return $this->container['projectId'];
    }

    /**
     * Sets projectId
     *
     * @param int|null $projectId Panel project id
     *
     * @return self
     */
    public function setProjectId($projectId)
    {
        $this->container['projectId'] = $projectId;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId Panel employee id
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets panelType
     *
     * @return string|null
     */
    public function getPanelType()
    {
        return $this->container['panelType'];
    }

    /**
     * Sets panelType
     *
     * @param string|null $panelType Panel type
     *
     * @return self
     */
    public function setPanelType($panelType)
    {
        $allowedValues = $this->getPanelTypeAllowableValues();
        if (!is_null($panelType) && !in_array($panelType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'panelType', must be one of '%s'",
                    $panelType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['panelType'] = $panelType;

        return $this;
    }

    /**
     * Gets registerType
     *
     * @return string|null
     */
    public function getRegisterType()
    {
        return $this->container['registerType'];
    }

    /**
     * Sets registerType
     *
     * @param string|null $registerType Register type
     *
     * @return self
     */
    public function setRegisterType($registerType)
    {
        $allowedValues = $this->getRegisterTypeAllowableValues();
        if (!is_null($registerType) && !in_array($registerType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'registerType', must be one of '%s'",
                    $registerType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['registerType'] = $registerType;

        return $this;
    }

    /**
     * Gets includeProjects
     *
     * @return bool|null
     */
    public function getIncludeProjects()
    {
        return $this->container['includeProjects'];
    }

    /**
     * Sets includeProjects
     *
     * @param bool|null $includeProjects Include project tickets
     *
     * @return self
     */
    public function setIncludeProjects($includeProjects)
    {
        $this->container['includeProjects'] = $includeProjects;

        return $this;
    }

    /**
     * Gets includeSubTickets
     *
     * @return bool|null
     */
    public function getIncludeSubTickets()
    {
        return $this->container['includeSubTickets'];
    }

    /**
     * Sets includeSubTickets
     *
     * @param bool|null $includeSubTickets Include sub tickets
     *
     * @return self
     */
    public function setIncludeSubTickets($includeSubTickets)
    {
        $this->container['includeSubTickets'] = $includeSubTickets;

        return $this;
    }

    /**
     * Gets includeWaitingStates
     *
     * @return bool|null
     */
    public function getIncludeWaitingStates()
    {
        return $this->container['includeWaitingStates'];
    }

    /**
     * Sets includeWaitingStates
     *
     * @param bool|null $includeWaitingStates Include tickets with waiting status
     *
     * @return self
     */
    public function setIncludeWaitingStates($includeWaitingStates)
    {
        $this->container['includeWaitingStates'] = $includeWaitingStates;

        return $this;
    }

    /**
     * Gets visibility
     *
     * @return string|null
     */
    public function getVisibility()
    {
        return $this->container['visibility'];
    }

    /**
     * Sets visibility
     *
     * @param string|null $visibility Panel visibility
     *
     * @return self
     */
    public function setVisibility($visibility)
    {
        $allowedValues = $this->getVisibilityAllowableValues();
        if (!is_null($visibility) && !in_array($visibility, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'visibility', must be one of '%s'",
                    $visibility,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['visibility'] = $visibility;

        return $this;
    }

    /**
     * Gets companies
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentCompanies[]|null
     */
    public function getCompanies()
    {
        return $this->container['companies'];
    }

    /**
     * Sets companies
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentCompanies[]|null $companies Array of panel companies
     *
     * @return self
     */
    public function setCompanies($companies)
    {
        $this->container['companies'] = $companies;

        return $this;
    }

    /**
     * Gets employees
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentEmployees[]|null
     */
    public function getEmployees()
    {
        return $this->container['employees'];
    }

    /**
     * Sets employees
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentEmployees[]|null $employees Array of panel employees
     *
     * @return self
     */
    public function setEmployees($employees)
    {
        $this->container['employees'] = $employees;

        return $this;
    }

    /**
     * Gets departments
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentDepartments[]|null
     */
    public function getDepartments()
    {
        return $this->container['departments'];
    }

    /**
     * Sets departments
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentDepartments[]|null $departments Array of panel departments
     *
     * @return self
     */
    public function setDepartments($departments)
    {
        $this->container['departments'] = $departments;

        return $this;
    }

    /**
     * Gets tags
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTags[]|null
     */
    public function getTags()
    {
        return $this->container['tags'];
    }

    /**
     * Sets tags
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTags[]|null $tags Array of panel tags
     *
     * @return self
     */
    public function setTags($tags)
    {
        $this->container['tags'] = $tags;

        return $this;
    }

    /**
     * Gets ticketTypes
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTicketTypes[]|null
     */
    public function getTicketTypes()
    {
        return $this->container['ticketTypes'];
    }

    /**
     * Sets ticketTypes
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTicketTypes[]|null $ticketTypes Array of panel ticket types
     *
     * @return self
     */
    public function setTicketTypes($ticketTypes)
    {
        $this->container['ticketTypes'] = $ticketTypes;

        return $this;
    }

    /**
     * Gets ticketStatus
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTicketStatus[]|null
     */
    public function getTicketStatus()
    {
        return $this->container['ticketStatus'];
    }

    /**
     * Sets ticketStatus
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20068ContentTicketStatus[]|null $ticketStatus Array of panel ticket status
     *
     * @return self
     */
    public function setTicketStatus($ticketStatus)
    {
        $this->container['ticketStatus'] = $ticketStatus;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


